package com.zipcodewilmington.gildedrose;


import javax.xml.bind.SchemaOutputResolver;

public class Inventory {
    private Item[] items;

    public Inventory(Item[] items) {
        super();
        this.items = items;
    }

    public boolean isAgedBrie(Item item) {
        return item.getName().equals("Aged Brie");
    }

    public boolean isBackstagePass(Item item) {
        return item.getName().equals("Backstage passes to a TAFKAL80ETC concert");
    }

    public boolean isSulfuras(Item item) {
        return item.getName().equals("Sulfuras, Hand of Ragnaros");
    }

    public boolean isConjuredItem(Item item) {
        return item.getName().equals("Sulfuros, Hand of Rognoros (not to be confused with Ragnaros)");
    }

    public void updateQuality(Item item) {
        if (isAgedBrie(item)) {
            if (item.getSellIn() > 0 && item.getQuality() < 50) {
                item.setQuality(item.getQuality() + 1);
            } else if (item.getSellIn() < 0 && item.getQuality() < 50) {
                item.setQuality(item.getQuality() + 2);
            }
        } else if (isBackstagePass(item)) {
            if (item.getSellIn() > 0 && item.getSellIn() > 10 && item.getQuality() >= 0) {
                item.setQuality(item.getQuality() - 1);
            } else if (item.getSellIn() <= 10 && item.getSellIn() > 5 && item.getQuality() < 50) {
                item.setQuality(item.getQuality() + 2);
            } else if (item.getSellIn() <= 5 && item.getSellIn() > 0 && item.getQuality() < 50) {
                item.setQuality(item.getQuality() + 3);
            } else {
                item.setQuality(0);
            }
        } else if (isConjuredItem(item)) {
            if (item.getSellIn() > 0 && item.getQuality() >= 0) {
                item.setQuality(item.getQuality() - 2);
            } else if (item.getQuality() >= 0) {
                item.setQuality(item.getQuality() - 4);
            }
        } else if (isSulfuras(item)) {
            item.setQuality(80);
        } else {
            if (item.getSellIn() > 0 && item.getQuality() >= 0) {
                item.setQuality(item.getQuality() - 1);
            } else if (item.getQuality() >= 0) {
                item.setQuality(item.getQuality() - 2);
            }
        }
    }

    public void updateSellIn(Item item) {
        if (!isSulfuras(item)) {
            item.setSellIn(item.getSellIn() - 1);
        }
    }
}


//    public void updateQuality1() {
//        for (int i = 0; i < items.length; i++) {
//            if (!items[i].getName().equals("Aged Brie") && !items[i].getName().equals("Backstage passes to a TAFKAL80ETC concert")) {
//                if (items[i].getQuality() > 0) {
//                    if (!items[i].getName().equals("Sulfuras, Hand of Ragnaros")) {
//                        items[i].setQuality(items[i].getQuality() - 1);
//                    }
//                }
//            } else {
//                if (items[i].getQuality() < 50) {
//                    items[i].setQuality(items[i].getQuality() + 1);
//
//                    if (items[i].getName() == "Backstage passes to a TAFKAL80ETC concert") {
//                        if (items[i].getSellIn() < 11) {
//                            if (items[i].getQuality() < 50) {
//                                items[i].setQuality(items[i].getQuality() + 1);
//                            }
//                        }
//
//                        if (items[i].getSellIn() < 6) {
//                            if (items[i].getQuality() < 50) {
//                                items[i].setQuality(items[i].getQuality() + 1);
//                            }
//                        }
//                    }
//                }
//            }
//
//            if (!items[i].getName().equals("Sulfuras, Hand of Ragnaros")) {
//                items[i].setSellIn(items[i].getSellIn() - 1);
//            }
//
//            if (items[i].getSellIn() < 0) {
//                if (!items[i].getName().equals("Aged Brie")) {
//                    if (!items[i].getName().equals("Backstage passes to a TAFKAL80ETC concert")) {
//                        if (items[i].getQuality() > 0) {
//                            if (!items[i].getName().equals("Sulfuras, Hand of Ragnaros")) {
//                                items[i].setQuality(items[i].getQuality() - 1);
//                            }
//                        }
//                    } else {
//                        items[i].setQuality(items[i].getQuality()
//                                - items[i].getQuality());
//                    }
//                } else {
//                    if (items[i].getQuality() < 50) {
//                        items[i].setQuality(items[i].getQuality() + 1);
//                    }
//                }
//            }
//        }
//    }
//}